SDL_vulkan.h File Reference
`#include "SDL_video.h"`
`#include "begin_code.h"`
`#include "close_code.h"`
Include dependency graph for SDL_vulkan.h:
This graph shows which files directly or indirectly include this file:

Go to the source code of this file.

## Macros

#define | VK_DEFINE_HANDLE(object) typedef struct object##_T* object;
#define | VK_DEFINE_NON_DISPATCHABLE_HANDLE(object) typedef uint64_t object;

## Typedefs

typedef VkInstance | SDL_vulkanInstance
typedef VkSurfaceKHR | SDL_vulkanSurface

## Functions

Vulkan support functions

Note
  SDL_Vulkan_GetInstanceExtensions & SDL_Vulkan_CreateSurface API is compatable with Tizen's implementation of Vulkan in SDL.

int | SDL_Vulkan_LoadLibrary (const char *path)
| Dynamically load a Vulkan loader library. More...
void * | SDL_Vulkan_GetVkGetInstanceProcAddr (void)
| Get the address of the `vkGetInstanceProcAddr` function. More...
void | SDL_Vulkan_UnloadLibrary (void)
| Unload the Vulkan loader library previously loaded by `SDL_Vulkan_LoadLibrary()`. More...
SDL_bool | SDL_Vulkan_GetInstanceExtensions (SDL_Window *window, unsigned int *pCount, const char **pNames)
| Get the names of the Vulkan instance extensions needed to create a surface with `SDL_Vulkan_CreateSurface()`. More...
SDL_bool | SDL_Vulkan_CreateSurface (SDL_Window *window, VkInstance instance, VkSurfaceKHR *surface)
| Create a Vulkan rendering surface for a window. More...
void | SDL_Vulkan_GetDrawableSize (SDL_Window *window, int *w, int *h)
| Get the size of a window's underlying drawable in pixels (for use with setting viewport, scissor & etc). More...

## Detailed Description

Header file for functions to creating Vulkan surfaces on SDL windows.

Definition in file SDL_vulkan.h.

## Macro Definition Documentation

## VK_DEFINE_HANDLE

#define VK_DEFINE_HANDLE | ( |  | object | ) | typedef struct object##_T* object;

Definition at line 44 of file SDL_vulkan.h.

## VK_DEFINE_NON_DISPATCHABLE_HANDLE

#define VK_DEFINE_NON_DISPATCHABLE_HANDLE | ( |  | object | ) | typedef uint64_t object;

Definition at line 49 of file SDL_vulkan.h.

## Typedef Documentation

## SDL_vulkanInstance

typedef VkInstance SDL_vulkanInstance

Definition at line 57 of file SDL_vulkan.h.

## SDL_vulkanSurface

typedef VkSurfaceKHR SDL_vulkanSurface

Definition at line 58 of file SDL_vulkan.h.

## Function Documentation

## SDL_Vulkan_CreateSurface()

SDL_bool SDL_Vulkan_CreateSurface | ( | SDL_Window * | window,
|  | VkInstance | instance,
|  | VkSurfaceKHR * | surface
| ) |  |

Create a Vulkan rendering surface for a window.

Parameters

  [in] | window | SDL_Window to which to attach the rendering surface.
  [in] | instance | handle to the Vulkan instance to use.
  [out] | surface | pointer to a VkSurfaceKHR handle to receive the handle of the newly created surface.

Returns
  `SDL_TRUE` on success, `SDL_FALSE` on error.

VkInstance instance;
SDL_Window *window;
// create instance and window
// create the Vulkan surface
VkSurfaceKHR surface;
if(!SDL_Vulkan_CreateSurface(window, instance, &surface))
handle_error();

Note
  window should have been created with the `SDL_WINDOW_VULKAN` flag.
  instance should have been created with the extensions returned by `SDL_Vulkan_CreateSurface()` enabled.

See also
  SDL_Vulkan_GetInstanceExtensions()

Definition at line 4042 of file SDL_video.c.

References CHECK_WINDOW_MAGIC, SDL_Window::flags, NOT_A_VULKAN_WINDOW, SDL_FALSE, SDL_InvalidParamError, SDL_SetError, SDL_WINDOW_VULKAN, and SDL_VideoDevice::Vulkan_CreateSurface.

{
CHECK_WINDOW_MAGIC(window, SDL_FALSE);
if (!(window->flags & SDL_WINDOW_VULKAN)) {
SDL_SetError(NOT_A_VULKAN_WINDOW);
return SDL_FALSE;
}
if (!instance) {
SDL_InvalidParamError("instance");
return SDL_FALSE;
}
if (!surface) {
SDL_InvalidParamError("surface");
return SDL_FALSE;
}
return _this->Vulkan_CreateSurface(_this, window, instance, surface);
}
NOT_A_VULKAN_WINDOW
#define NOT_A_VULKAN_WINDOW
Definition: SDL_video.c:3970
SDL_FALSE
Definition: SDL_stdinc.h:141
surface
EGLSurface surface
Definition: eglext.h:248
SDL_InvalidParamError
#define SDL_InvalidParamError(param)
Definition: SDL_error.h:54
_this
static SDL_VideoDevice * _this
Definition: SDL_video.c:121
SDL_VideoDevice::Vulkan_CreateSurface
SDL_bool(* Vulkan_CreateSurface)(_THIS, SDL_Window *window, VkInstance instance, VkSurfaceKHR *surface)
Definition: SDL_sysvideo.h:273
SDL_WINDOW_VULKAN
Definition: SDL_video.h:122
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30
CHECK_WINDOW_MAGIC
#define CHECK_WINDOW_MAGIC(window, retval)
Definition: SDL_video.c:123
SDL_Window::flags
Uint32 flags
Definition: SDL_sysvideo.h:83

## SDL_Vulkan_GetDrawableSize()

void SDL_Vulkan_GetDrawableSize | ( | SDL_Window * | window,
|  | int * | w,
|  | int * | h
| ) |  |

Get the size of a window's underlying drawable in pixels (for use with setting viewport, scissor & etc).

Parameters

  window | SDL_Window from which the drawable size should be queried
  w | Pointer to variable for storing the width in pixels, may be NULL
  h | Pointer to variable for storing the height in pixels, may be NULL

This may differ from SDL_GetWindowSize() if we're rendering to a high-DPI drawable, i.e. the window was created with SDL_WINDOW_ALLOW_HIGHDPI on a platform with high-DPI support (Apple calls this "Retina"), and not disabled by the `SDL_HINT_VIDEO_HIGHDPI_DISABLED` hint.

Note
  On macOS high-DPI support must be enabled for an application by setting NSHighResolutionCapable to true in its Info.plist.

See also
  SDL_GetWindowSize()
  SDL_CreateWindow()

Definition at line 4066 of file SDL_video.c.

References CHECK_WINDOW_MAGIC, SDL_GetWindowSize(), and SDL_VideoDevice::Vulkan_GetDrawableSize.

{
CHECK_WINDOW_MAGIC(window,);
if (_this->Vulkan_GetDrawableSize) {
_this->Vulkan_GetDrawableSize(_this, window, w, h);
} else {
SDL_GetWindowSize(window, w, h);
}
}
h
GLfloat GLfloat GLfloat GLfloat h
Definition: SDL_opengl_glext.h:1946
_this
static SDL_VideoDevice * _this
Definition: SDL_video.c:121
SDL_VideoDevice::Vulkan_GetDrawableSize
void(* Vulkan_GetDrawableSize)(_THIS, SDL_Window *window, int *w, int *h)
Definition: SDL_sysvideo.h:274
w
GLubyte GLubyte GLubyte GLubyte w
Definition: SDL_opengl_glext.h:731
SDL_GetWindowSize
void SDL_GetWindowSize(SDL_Window *window, int *w, int *h)
Get the size of a window&#39;s client area.
Definition: SDL_video.c:1954
CHECK_WINDOW_MAGIC
#define CHECK_WINDOW_MAGIC(window, retval)
Definition: SDL_video.c:123

## SDL_Vulkan_GetInstanceExtensions()

SDL_bool SDL_Vulkan_GetInstanceExtensions | ( | SDL_Window * | window,
|  | unsigned int * | pCount,
|  | const char ** | pNames
| ) |  |

Get the names of the Vulkan instance extensions needed to create a surface with `SDL_Vulkan_CreateSurface()`.

Parameters

  [in] | window | Window for which the required Vulkan instance extensions should be retrieved
  [in,out] | count | pointer to an `unsigned` related to the number of required Vulkan instance extensions
  [out] | names | `NULL` or a pointer to an array to be filled with the required Vulkan instance extensions

Returns
  `SDL_TRUE` on success, `SDL_FALSE` on error.

If pNames is `NULL`, then the number of required Vulkan instance extensions is returned in pCount. Otherwise, pCount must point to a variable set to the number of elements in the pNames array, and on return the variable is overwritten with the number of names actually written to pNames. If pCount is less than the number of required extensions, at most pCount structures will be written. If pCount is smaller than the number of required extensions, `SDL_FALSE` will be returned instead of `SDL_TRUE`, to indicate that not all the required extensions were returned.

Note
  The returned list of extensions will contain `VK_KHR_surface` and zero or more platform specific extensions
  The extension names queried here must be enabled when calling VkCreateInstance, otherwise surface creation will fail.
  `window` should have been created with the `SDL_WINDOW_VULKAN` flag.

unsigned int count;
// get count of required extensions
if(!SDL_Vulkan_GetInstanceExtensions(window, &count, NULL))
handle_error();
static const char *const additionalExtensions[] =
{
VK_EXT_DEBUG_REPORT_EXTENSION_NAME, // example additional extension
};
size_t additionalExtensionsCount = sizeof(additionalExtensions) / sizeof(additionalExtensions[0]);
size_t extensionCount = count + additionalExtensionsCount;
const char **names = malloc(sizeof(const char *) * extensionCount);
if(!names)
handle_error();
// get names of required extensions
if(!SDL_Vulkan_GetInstanceExtensions(window, &count, names))
handle_error();
// copy additional extensions after required extensions
for(size_t i = 0; i < additionalExtensionsCount; i++)
names[i + count] = additionalExtensions[i];
VkInstanceCreateInfo instanceCreateInfo = {};
instanceCreateInfo.enabledExtensionCount = extensionCount;
instanceCreateInfo.ppEnabledExtensionNames = names;
// fill in rest of instanceCreateInfo
VkInstance instance;
// create the Vulkan instance
VkResult result = vkCreateInstance(&instanceCreateInfo, NULL, &instance);
free(names);

See also
  SDL_Vulkan_CreateSurface()

## SDL_Vulkan_GetVkGetInstanceProcAddr()

void* SDL_Vulkan_GetVkGetInstanceProcAddr | ( | void |  | ) |

Get the address of the `vkGetInstanceProcAddr` function.

Note
  This should be called after either calling SDL_Vulkan_LoadLibrary or creating an SDL_Window with the SDL_WINDOW_VULKAN flag.

Definition at line 3996 of file SDL_video.c.

References SDL_VideoDevice::loader_loaded, NULL, SDL_SetError, SDL_UninitializedVideo(), SDL_VideoDevice::vkGetInstanceProcAddr, and SDL_VideoDevice::vulkan_config.

{
if (!_this) {
SDL_UninitializedVideo();
return NULL;
}
if (!_this->vulkan_config.loader_loaded) {
SDL_SetError("No Vulkan loader has been loaded");
return NULL;
}
return _this->vulkan_config.vkGetInstanceProcAddr;
}
SDL_VideoDevice::vulkan_config
struct SDL_VideoDevice::@35 vulkan_config
_this
static SDL_VideoDevice * _this
Definition: SDL_video.c:121
NULL
#define NULL
Definition: begin_code.h:164
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30
SDL_VideoDevice::loader_loaded
int loader_loaded
Definition: SDL_sysvideo.h:370
SDL_UninitializedVideo
static int SDL_UninitializedVideo()
Definition: SDL_video.c:440
SDL_VideoDevice::vkGetInstanceProcAddr
PFN_vkGetInstanceProcAddr vkGetInstanceProcAddr
Definition: SDL_sysvideo.h:368

## SDL_Vulkan_LoadLibrary()

int SDL_Vulkan_LoadLibrary | ( | const char * | path | ) |

Dynamically load a Vulkan loader library.

Parameters

  [in] | path | The platform dependent Vulkan loader library name, or `NULL`.

Returns
  `0` on success, or `-1` if the library couldn't be loaded.

If path is NULL SDL will use the value of the environment variable `SDL_VULKAN_LIBRARY`, if set, otherwise it loads the default Vulkan loader library.

This should be called after initializing the video driver, but before creating any Vulkan windows. If no Vulkan loader library is loaded, the default library will be loaded upon creation of the first Vulkan window.

Note
  It is fairly common for Vulkan applications to link with libvulkan instead of explicitly loading it at run time. This will work with SDL provided the application links to a dynamic library and both it and SDL use the same search path.
  If you specify a non-NULL `path`, an application should retrieve all of the Vulkan functions it uses from the dynamic library using `SDL_Vulkan_GetVkGetInstanceProcAddr()` unless you can guarantee `path` points to the same vulkan loader library the application linked to.
  On Apple devices, if path is NULL, SDL will attempt to find the vkGetInstanceProcAddr address within all the mach-o images of the current process. This is because it is fairly common for Vulkan applications to link with libvulkan (and historically MoltenVK was provided as a static library). If it is not found then, on macOS, SDL will attempt to load `vulkan.framework/vulkan`, `libvulkan.1.dylib`, `MoltenVK.framework/MoltenVK` and `libMoltenVK.dylib` in that order. On iOS SDL will attempt to load `libMoltenVK.dylib`. Applications using a dynamic framework or .dylib must ensure it is included in its application bundle.
  On non-Apple devices, application linking with a static libvulkan is not supported. Either do not link to the Vulkan loader or link to a dynamic library version.
  This function will fail if there are no working Vulkan drivers installed.

See also
  SDL_Vulkan_GetVkGetInstanceProcAddr()
  SDL_Vulkan_UnloadLibrary()

Definition at line 3972 of file SDL_video.c.

References SDL_VideoDevice::loader_loaded, SDL_VideoDevice::loader_path, retval, SDL_SetError, SDL_strcmp, SDL_UninitializedVideo(), SDL_VideoDevice::vulkan_config, and SDL_VideoDevice::Vulkan_LoadLibrary.

Referenced by SDL_CreateWindow().

{
int retval;
if (!_this) {
SDL_UninitializedVideo();
return -1;
}
if (_this->vulkan_config.loader_loaded) {
if (path && SDL_strcmp(path, _this->vulkan_config.loader_path) != 0) {
return SDL_SetError("Vulkan loader library already loaded");
}
retval = 0;
} else {
if (!_this->Vulkan_LoadLibrary) {
return SDL_SetError("No Vulkan support in video driver");
}
retval = _this->Vulkan_LoadLibrary(_this, path);
}
if (retval == 0) {
_this->vulkan_config.loader_loaded++;
}
return retval;
}
SDL_VideoDevice::Vulkan_LoadLibrary
int(* Vulkan_LoadLibrary)(_THIS, const char *path)
Definition: SDL_sysvideo.h:270
SDL_VideoDevice::vulkan_config
struct SDL_VideoDevice::@35 vulkan_config
_this
static SDL_VideoDevice * _this
Definition: SDL_video.c:121
SDL_VideoDevice::loader_path
char loader_path[256]
Definition: SDL_sysvideo.h:371
retval
SDL_bool retval
Definition: testgamecontroller.c:65
SDL_SetError
#define SDL_SetError
Definition: SDL_dynapi_overrides.h:30
SDL_VideoDevice::loader_loaded
int loader_loaded
Definition: SDL_sysvideo.h:370
SDL_UninitializedVideo
static int SDL_UninitializedVideo()
Definition: SDL_video.c:440
path
GLsizei const GLchar *const * path
Definition: SDL_opengl_glext.h:3730
SDL_strcmp
#define SDL_strcmp
Definition: SDL_dynapi_overrides.h:417

## SDL_Vulkan_UnloadLibrary()

void SDL_Vulkan_UnloadLibrary | ( | void |  | ) |

Unload the Vulkan loader library previously loaded by `SDL_Vulkan_LoadLibrary()`.

See also
  SDL_Vulkan_LoadLibrary()

Definition at line 4009 of file SDL_video.c.

References SDL_VideoDevice::loader_loaded, SDL_UninitializedVideo(), SDL_VideoDevice::vulkan_config, and SDL_VideoDevice::Vulkan_UnloadLibrary.

Referenced by SDL_DestroyWindow().

{
if (!_this) {
SDL_UninitializedVideo();
return;
}
if (_this->vulkan_config.loader_loaded > 0) {
if (--_this->vulkan_config.loader_loaded > 0) {
return;
}
if (_this->Vulkan_UnloadLibrary) {
_this->Vulkan_UnloadLibrary(_this);
}
}
}
SDL_VideoDevice::vulkan_config
struct SDL_VideoDevice::@35 vulkan_config
_this
static SDL_VideoDevice * _this
Definition: SDL_video.c:121
SDL_VideoDevice::Vulkan_UnloadLibrary
void(* Vulkan_UnloadLibrary)(_THIS)
Definition: SDL_sysvideo.h:271
SDL_VideoDevice::loader_loaded
int loader_loaded
Definition: SDL_sysvideo.h:370
SDL_UninitializedVideo
static int SDL_UninitializedVideo()
Definition: SDL_video.c:440